//+------------------------------------------------------------------+
//|                                                      VWAP_v1.mq4 |
//|                                                       Akif TOKUZ |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Akif TOKUZ"
#property link      "akifusenet@gmail.com"

#property indicator_chart_window
#property indicator_buffers 7

#property indicator_color1 Aqua        //VWAP
#property indicator_width1 2

#property indicator_color2 Green       //SD1Pos
#property indicator_width2 1
#property indicator_style2 2

#property indicator_color3 Red         //SD1Neg
#property indicator_width3 1
#property indicator_style3 2

#property indicator_color4 DarkOliveGreen//SD2Pos
#property indicator_width4 1
#property indicator_style4 2

#property indicator_color5 Crimson     //SD2Neg
#property indicator_width5 1
#property indicator_style5 2

#property indicator_color6 DarkGreen   //SD3Pos
#property indicator_width6 1
#property indicator_style6 2

#property indicator_color7 FireBrick   //SD3Neg
#property indicator_width7 1
#property indicator_style7 2


//---- input parameters
extern datetime   StartDate=D'2009.08.07 00:00';
extern bool       Show_SD1=true;
extern bool       Show_SD2=true;
extern bool       Show_SD3=true;

//---- indicator buffers
double VWAP[];
double SD1Pos[];
double SD1Neg[];
double SD2Pos[];
double SD2Neg[];
double SD3Pos[];
double SD3Neg[];

//---- global variables
double TotalVolume=0;
double TotalPV=0;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);

   SetIndexBuffer(0,VWAP);
   SetIndexBuffer(1,SD1Pos);
   SetIndexBuffer(2,SD1Neg);
   SetIndexBuffer(3,SD2Pos);
   SetIndexBuffer(4,SD2Neg);
   SetIndexBuffer(5,SD3Pos);
   SetIndexBuffer(6,SD3Neg);   

   SetIndexLabel(0,"VWAP");
   SetIndexLabel(1,"SD1Pos");         
   SetIndexLabel(2,"SD1Neg");      
   SetIndexLabel(3,"SD2Pos");      
   SetIndexLabel(4,"SD2Neg");      
   SetIndexLabel(5,"SD3Pos");
   SetIndexLabel(6,"SD3Neg");
   
   if (Show_SD1==true)
   {
    SetIndexStyle(1,DRAW_LINE);
    SetIndexStyle(2,DRAW_LINE);
   }
   else
   {
     SetIndexStyle(1,DRAW_NONE);
     SetIndexStyle(2,DRAW_NONE);
   }
   
   
   if (Show_SD2==true)
   {
    SetIndexStyle(3,DRAW_LINE);
    SetIndexStyle(4,DRAW_LINE);
   }
   else
   {
     SetIndexStyle(3,DRAW_NONE);
     SetIndexStyle(4,DRAW_NONE);
   }


   if (Show_SD3==true)
   {
    SetIndexStyle(5,DRAW_LINE);
    SetIndexStyle(6,DRAW_LINE);
   }
   else
   {
     SetIndexStyle(5,DRAW_NONE);
     SetIndexStyle(6,DRAW_NONE);
   }

   string short_name="VWAP";
   IndicatorShortName(short_name);
   
  
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }


// Finds the bar number for the given date
int FindStartIndex(datetime startDate)
{
   for (int i=Bars-1; i>=0; i--)
   {      
      if (Time[i]>=StartDate) return (i);
   }
   return( 0);
} 


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   double avg;
   double SD;
   int k,Bars_Back;
   double avg2;
   double diff;
  
  
   //---- check for possible errors
   if(counted_bars<0) return(-1);

   // For historical bars
   for (int i=Bars-counted_bars-1; i>0; i--)
   {
      if (Time[i] >= StartDate )
      {            
            avg=(High[i]+Low[i]+Close[i])/3;
            TotalVolume+=Volume[i];
            TotalPV+=Volume[i]*avg;   
            VWAP[i]=TotalPV/TotalVolume;                   
            
            SD=0;         
            Bars_Back=FindStartIndex(StartDate);
            for (k = Bars_Back; k >= i; k--)
            {
               avg2=(High[k]+Close[k]+Low[k])/3;
               diff=avg2-VWAP[i];
               SD+=(Volume[k]/TotalVolume)*(diff*diff);         
             }
             SD=MathSqrt(SD);
             SD1Pos[i]=VWAP[i]+SD;
             SD1Neg[i]=VWAP[i]-SD;
             SD2Pos[i]=VWAP[i]+2*SD;
             SD2Neg[i]=VWAP[i]-2*SD;            
             SD3Pos[i]=VWAP[i]+3*SD;
             SD3Neg[i]=VWAP[i]-3*SD;                        
      }
   }
   
   // For current bar
      if (Time[0] >= StartDate )
      {            
            avg=(High[0]+Low[0]+Close[0])/3;
            VWAP[0]=(TotalPV+Volume[0]*avg)/(TotalVolume+Volume[0]);                         
            
            SD=0;         
            Bars_Back=FindStartIndex(StartDate);
            for (k = Bars_Back; k >= 0; k--)
            {
               avg2=(High[k]+Close[k]+Low[k])/3;
               diff=avg2-VWAP[0];
               SD+=(Volume[k]/(TotalVolume+Volume[0]))*(diff*diff);         
             }
             SD=MathSqrt(SD);
             SD1Pos[i]=VWAP[i]+SD;
             SD1Neg[i]=VWAP[i]-SD;
             SD2Pos[i]=VWAP[i]+2*SD;
             SD2Neg[i]=VWAP[i]-2*SD;            
             SD3Pos[i]=VWAP[i]+3*SD;
             SD3Neg[i]=VWAP[i]-3*SD;                        
      }
   
   
  //---- done
  return(0);
   }
//+------------------------------------------------------------------+